Index: main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py
===================================================================
--- main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 11253)
+++ main/waeup.kofa/trunk/src/waeup/kofa/students/browser.py	(revision 11254)
@@ -39,6 +39,4 @@
 from waeup.kofa.browser.breadcrumbs import Breadcrumb
 from waeup.kofa.browser.pages import ContactAdminForm, ExportCSVView, doll_up
-from waeup.kofa.browser.resources import (
-    datepicker, datatable, tabs, warning, toggleall)
 from waeup.kofa.browser.layout import jsaction, action, UtilityView
 from waeup.kofa.browser.interfaces import ICaptchaManager
@@ -107,5 +105,5 @@
     """Flash a lock message.
     """
-    view.flash(_('The requested form is locked (read-only).'))
+    view.flash(_('The requested form is locked (read-only).'), type="warning")
     view.redirect(view.url(view.context))
     return
@@ -122,4 +120,5 @@
         value._p_activate()
         value_dict = dict([i for i in value.__dict__.items()])
+        value_dict['url'] = view.url(value)
         value_dict['removable_by_student'] = value.removable_by_student
         value_dict['mandatory'] = translate(str(value.mandatory), 'zope',
@@ -155,10 +154,10 @@
         view.flash(_(
             'Total credits exceed ${a}.',
-            mapping = {'a': max_credits}))
+            mapping = {'a': max_credits}), type="warning")
         return False
     try:
         view.context.addCourseTicket(ticket, course)
     except KeyError:
-        view.flash(_('The ticket exists.'))
+        view.flash(_('The ticket exists.'), type="warning")
         return False
     view.flash(_('Successfully added ${a}.',
@@ -258,10 +257,9 @@
     grok.require('waeup.viewStudentsContainer')
     grok.template('containerpage')
-    label = _('Student Section')
+    label = _('Find students')
     search_button = _('Find student(s)')
     pnav = 4
 
     def update(self, *args, **kw):
-        datatable.need()
         form = self.request.form
         self.hitlist = []
@@ -280,5 +278,5 @@
         else:
             if 'search' in form:
-                self.flash(_('Empty search string'))
+                self.flash(_('Empty search string'), type="warning")
             return
         if self.searchtype == 'current_session':
@@ -286,10 +284,11 @@
                 self.searchterm = int(self.searchterm)
             except ValueError:
-                self.flash(_('Only year dates allowed (e.g. 2011).'))
+                self.flash(_('Only year dates allowed (e.g. 2011).'),
+                           type="danger")
                 return
         self.hitlist = search(query=self.searchterm,
             searchtype=self.searchtype, view=self)
         if not self.hitlist:
-            self.flash(_('No student found.'))
+            self.flash(_('No student found.'), type="warning")
         return
 
@@ -307,7 +306,4 @@
 
     def update(self, *args, **kw):
-        datatable.need()
-        toggleall.need()
-        warning.need()
         form = self.request.form
         self.hitlist = []
@@ -323,5 +319,5 @@
         else:
             if 'search' in form:
-                self.flash(_('Empty search string'))
+                self.flash(_('Empty search string'), type="warning")
             return
         if self.searchtype == 'current_session':
@@ -329,5 +325,6 @@
                 self.searchterm = int(self.searchterm)
             except ValueError:
-                self.flash('Only year dates allowed (e.g. 2011).')
+                self.flash(_('Only year dates allowed (e.g. 2011).'),
+                           type="danger")
                 return
         if not 'entries' in form:
@@ -335,7 +332,7 @@
                 searchtype=self.searchtype, view=self)
             if not self.hitlist:
-                self.flash(_('No student found.'))
+                self.flash(_('No student found.'), type="warning")
             if 'remove' in form:
-                self.flash(_('No item selected.'))
+                self.flash(_('No item selected.'), type="warning")
             return
         entries = form['entries']
@@ -495,5 +492,5 @@
             self.flash(_('Your message has been sent.'))
         else:
-            self.flash(_('An smtp server error occurred.'))
+            self.flash(_('An smtp server error occurred.'), type="danger")
         return
 
@@ -535,11 +532,4 @@
 
     def update(self):
-        datepicker.need() # Enable jQuery datepicker in date fields.
-        tabs.need()
-        self.tab1 = self.tab2 = ''
-        qs = self.request.get('QUERY_STRING', '')
-        if not qs:
-            qs = 'tab1'
-        setattr(self, qs, 'active')
         super(StudentBaseManageFormPage, self).update()
         self.wf_info = IWorkflowInfo(self.context)
@@ -555,5 +545,5 @@
             errors = validator.validate_password(password, password_ctl)
             if errors:
-                self.flash( ' '.join(errors))
+                self.flash( ' '.join(errors), type="danger")
                 return
         changed_fields = self.applyData(self.context, **data)
@@ -764,14 +754,4 @@
         return form_fields
 
-    def update(self):
-        datepicker.need() # Enable jQuery datepicker in date fields.
-        tabs.need()
-        self.tab1 = self.tab2 = ''
-        qs = self.request.get('QUERY_STRING', '')
-        if not qs:
-            qs = 'tab1'
-        setattr(self, qs, 'active')
-        return super(StudentClearanceManageFormPage, self).update()
-
     @action(_('Save'), style='primary')
     def save(self, **data):
@@ -795,5 +775,5 @@
             self.flash(_('Student has been cleared.'))
         else:
-            self.flash(_('Student is in wrong state.'))
+            self.flash(_('Student is in wrong state.'), type="warning")
         self.redirect(self.url(self.context,'view_clearance'))
         return
@@ -814,5 +794,5 @@
     def update(self):
         if clearance_disabled_message(self.context):
-            self.flash(clearance_disabled_message(self.context))
+            self.flash(clearance_disabled_message(self.context), type="warning")
             self.redirect(self.url(self.context,'view_clearance'))
             return
@@ -824,11 +804,11 @@
             IWorkflowInfo(self.context).fireTransition('reset4')
             message = _('Clearance has been annulled.')
-            self.flash(message)
+            self.flash(message, type="warning")
         elif self.context.state == REQUESTED:
             IWorkflowInfo(self.context).fireTransition('reset3')
             message = _('Clearance request has been rejected.')
-            self.flash(message)
-        else:
-            self.flash(_('Student is in wrong state.'))
+            self.flash(message, type="warning")
+        else:
+            self.flash(_('Student is in wrong state.'), type="warning")
             self.redirect(self.url(self.context,'view_clearance'))
             return
@@ -987,12 +967,4 @@
             return
         super(StudyCourseManageFormPage, self).update()
-        tabs.need()
-        self.tab1 = self.tab2 = ''
-        qs = self.request.get('QUERY_STRING', '')
-        if not qs:
-            qs = 'tab1'
-        setattr(self, qs, 'active')
-        warning.need()
-        datatable.need()
         return
 
@@ -1003,5 +975,6 @@
         except ConstraintNotSatisfied:
             # The selected level might not exist in certificate
-            self.flash(_('Current level not available for certificate.'))
+            self.flash(_('Current level not available for certificate.'),
+                       type="warning")
             return
         notify(grok.ObjectModifiedEvent(self.context.__parent__))
@@ -1023,11 +996,12 @@
             yield(dict(code=code, title=title))
 
-    @action(_('Add study level'))
+    @action(_('Add study level'), style='primary')
     def addStudyLevel(self, **data):
         level_code = self.request.form.get('addlevel', None)
         level_session = self.request.form.get('level_session', None)
         if not level_session:
-            self.flash(_('You must select a session for the level.'))
-            self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+            self.flash(_('You must select a session for the level.'),
+                       type="warning")
+            self.redirect(self.url(self.context, u'@@manage')+'#tab2')
             return
         studylevel = createObject(u'waeup.StudentStudyLevel')
@@ -1039,6 +1013,6 @@
             self.flash(_('Study level has been added.'))
         except KeyError:
-            self.flash(_('This level exists.'))
-        self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+            self.flash(_('This level exists.'), type="warning")
+        self.redirect(self.url(self.context, u'@@manage')+'#tab2')
         return
 
@@ -1049,6 +1023,6 @@
             child_id = form['val_id']
         else:
-            self.flash(_('No study level selected.'))
-            self.redirect(self.url(self.context, '@@manage')+'?tab2')
+            self.flash(_('No study level selected.'), type="warning")
+            self.redirect(self.url(self.context, '@@manage')+'#tab2')
             return
         if not isinstance(child_id, list):
@@ -1063,5 +1037,5 @@
             self.context.writeLogMessage(
                 self,'removed: %s' % ', '.join(deleted))
-        self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+        self.redirect(self.url(self.context, u'@@manage')+'#tab2')
         return
 
@@ -1082,12 +1056,6 @@
     def update(self, SUBMIT=None):
         super(StudentTranscriptRequestPage, self).update()
-        tabs.need()
-        self.tab1 = self.tab2 = ''
-        qs = self.request.get('QUERY_STRING', '')
-        if not qs:
-            qs = 'tab1'
-        setattr(self, qs, 'active')
         if not self.context.state == GRADUATED:
-            self.flash(_("Wrong state"))
+            self.flash(_("Wrong state"), type="danger")
             self.redirect(self.url(self.context))
             return
@@ -1106,8 +1074,9 @@
             code = get_access_code(pin)
             if not code:
-                self.flash(_('Activation code is invalid.'))
+                self.flash(_('Activation code is invalid.'), type="warning")
                 return
             if code.state == USED:
-                self.flash(_('Activation code has already been used.'))
+                self.flash(_('Activation code has already been used.'),
+                           type="warning")
                 return
             # Mark pin as used (this also fires a pin related transition)
@@ -1117,5 +1086,6 @@
             # expect an exception, but the owner might be different
             if not invalidate_accesscode(pin, comment, self.context.student_id):
-                self.flash(_('You are not the owner of this access code.'))
+                self.flash(_('You are not the owner of this access code.'),
+                           type="warning")
                 return
             self.context.clr_code = pin
@@ -1157,12 +1127,6 @@
     def update(self, SUBMIT=None):
         super(StudentTranscriptRequestProcessFormPage, self).update()
-        tabs.need()
-        self.tab1 = self.tab2 = ''
-        qs = self.request.get('QUERY_STRING', '')
-        if not qs:
-            qs = 'tab1'
-        setattr(self, qs, 'active')
         if self.context.state != TRANSCRIPT:
-            self.flash(_('Student is in wrong state.'))
+            self.flash(_('Student is in wrong state.'), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -1222,5 +1186,6 @@
     def update(self):
         if not self.context.student.transcript_enabled:
-            self.flash(_('You are not allowed to view the transcript.'))
+            self.flash(_('You are not allowed to view the transcript.'),
+                       type="warning")
             self.redirect(self.url(self.context))
             return
@@ -1255,5 +1220,6 @@
     def update(self):
         if not self.context.student.transcript_enabled:
-            self.flash(_('You are not allowed to download the transcript.'))
+            self.flash(_('You are not allowed to download the transcript.'),
+                       type="warning")
             self.redirect(self.url(self.context))
             return
@@ -1319,18 +1285,16 @@
     pnav = 4
 
-    def update(self):
-        super(StudentTransferFormPage, self).update()
-        warning.need()
-        return
-
     @jsaction(_('Transfer'))
     def transferStudent(self, **data):
         error = self.context.transfer(**data)
         if error == -1:
-            self.flash(_('Current level does not match certificate levels.'))
+            self.flash(_('Current level does not match certificate levels.'),
+                       type="warning")
         elif error == -2:
-            self.flash(_('Former study course record incomplete.'))
+            self.flash(_('Former study course record incomplete.'),
+                       type="warning")
         elif error == -3:
-            self.flash(_('Maximum number of transfers exceeded.'))
+            self.flash(_('Maximum number of transfers exceeded.'),
+                       type="warning")
         else:
             self.flash(_('Successfully transferred.'))
@@ -1347,7 +1311,6 @@
 
     def update(self):
-        warning.need()
         if not self.context.has_key('studycourse_1'):
-            self.flash(_('No previous transfer.'))
+            self.flash(_('No previous transfer.'), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -1375,5 +1338,4 @@
     def update(self):
         super(StudyLevelDisplayFormPage, self).update()
-        datatable.need()
         return
 
@@ -1486,4 +1448,5 @@
     tabtwoactions = [_('Add course ticket'),
         _('Remove selected tickets'),_('Cancel')]
+    placeholder = _('Enter valid course code')
 
     def update(self, ADD=None, course=None):
@@ -1492,25 +1455,17 @@
             return
         super(StudyLevelManageFormPage, self).update()
-        tabs.need()
-        self.tab1 = self.tab2 = ''
-        qs = self.request.get('QUERY_STRING', '')
-        if not qs:
-            qs = 'tab1'
-        setattr(self, qs, 'active')
-        warning.need()
-        datatable.need()
         if ADD is not None:
             if not course:
-                self.flash(_('No valid course code entered.'))
-                self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+                self.flash(_('No valid course code entered.'), type="warning")
+                self.redirect(self.url(self.context, u'@@manage')+'#tab2')
                 return
             cat = queryUtility(ICatalog, name='courses_catalog')
             result = cat.searchResults(code=(course, course))
             if len(result) != 1:
-                self.flash(_('Course not found.'))
+                self.flash(_('Course not found.'), type="warning")
             else:
                 course = list(result)[0]
                 addCourseTicket(self, course)
-            self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+            self.redirect(self.url(self.context, u'@@manage')+'#tab2')
         return
 
@@ -1539,6 +1494,6 @@
             child_id = form['val_id']
         else:
-            self.flash(_('No ticket selected.'))
-            self.redirect(self.url(self.context, '@@manage')+'?tab2')
+            self.flash(_('No ticket selected.'), type="warning")
+            self.redirect(self.url(self.context, '@@manage')+'#tab2')
             return
         if not isinstance(child_id, list):
@@ -1554,5 +1509,5 @@
                 self,'removed: %s at %s' %
                 (', '.join(deleted), self.context.level))
-        self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+        self.redirect(self.url(self.context, u'@@manage')+'#tab2')
         return
 
@@ -1569,5 +1524,6 @@
             return
         if str(self.context.__parent__.current_level) != self.context.__name__:
-            self.flash(_('This level does not correspond current level.'))
+            self.flash(_('This level does not correspond current level.'),
+                       type="danger")
         elif self.context.student.state == REGISTERED:
             IWorkflowInfo(self.context.student).fireTransition(
@@ -1575,5 +1531,5 @@
             self.flash(_('Course list has been validated.'))
         else:
-            self.flash(_('Student is in the wrong state.'))
+            self.flash(_('Student is in the wrong state.'), type="warning")
         self.redirect(self.url(self.context))
         return
@@ -1594,5 +1550,6 @@
             return
         if str(self.context.__parent__.current_level) != self.context.__name__:
-            self.flash(_('This level does not correspond current level.'))
+            self.flash(_('This level does not correspond current level.'),
+                       type="danger")
             self.redirect(self.url(self.context))
             return
@@ -1606,5 +1563,5 @@
             self.flash(message)
         else:
-            self.flash(_('Student is in the wrong state.'))
+            self.flash(_('Student is in the wrong state.'), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -1634,10 +1591,10 @@
         return
 
-    @action(_('Add course ticket'))
+    @action(_('Add course ticket'), style='primary')
     def addCourseTicket(self, **data):
         course = data['course']
         success = addCourseTicket(self, course)
         if success:
-            self.redirect(self.url(self.context, u'@@manage')+'?tab2')
+            self.redirect(self.url(self.context, u'@@manage')+'#tab2')
         return
 
@@ -1719,10 +1676,4 @@
             mapping = {'a':self.context.__parent__.display_fullname})
 
-    def update(self):
-        super(PaymentsManageFormPage, self).update()
-        datatable.need()
-        warning.need()
-        return
-
     @jsaction(_('Remove selected tickets'))
     def delPaymentTicket(self, **data):
@@ -1731,5 +1682,5 @@
             child_id = form['val_id']
         else:
-            self.flash(_('No payment selected.'))
+            self.flash(_('No payment selected.'), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -1783,10 +1734,11 @@
                 self.flash(
                     _('Your current session does not match ' + \
-                    'accommodation session.'))
+                    'accommodation session.'), type="danger")
                 return
         if 'maintenance' in p_category:
             current_session = str(student['studycourse'].current_session)
             if not current_session in student['accommodation']:
-                self.flash(_('You have not yet booked accommodation.'))
+                self.flash(_('You have not yet booked accommodation.'),
+                           type="warning")
                 return
         students_utils = getUtility(IStudentsUtils)
@@ -1794,5 +1746,5 @@
             p_category, student, previous_session, previous_level)
         if error is not None:
-            self.flash(error)
+            self.flash(error, type="danger")
             return
         self.context[payment.p_id] = payment
@@ -1817,5 +1769,5 @@
     def update(self):
         if self.context.student.before_payment:
-            self.flash(_("No previous payment to be made."))
+            self.flash(_("No previous payment to be made."), type="warning")
             self.redirect(self.url(self.context))
         super(PreviousPaymentAddFormPage, self).update()
@@ -1832,5 +1784,5 @@
             p_category, student, previous_session, previous_level)
         if error is not None:
-            self.flash(error)
+            self.flash(error, type="danger")
             return
         self.context[payment.p_id] = payment
@@ -1865,5 +1817,5 @@
             balance_level, balance_amount)
         if error is not None:
-            self.flash(error)
+            self.flash(error, type="danger")
             return
         self.context[payment.p_id] = payment
@@ -1989,14 +1941,9 @@
             mapping = {'a':self.context.__parent__.display_fullname})
 
-    def update(self):
-        super(AccommodationManageFormPage, self).update()
-        datatable.need()
-        warning.need()
-        return
-
     @jsaction(_('Remove selected'))
     def delBedTickets(self, **data):
         if getattr(self.request.principal, 'user_type', None) == 'student':
-            self.flash(_('You are not allowed to remove bed tickets.'))
+            self.flash(_('You are not allowed to remove bed tickets.'),
+                       type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2005,5 +1952,5 @@
             child_id = form['val_id']
         else:
-            self.flash(_('No bed ticket selected.'))
+            self.flash(_('No bed ticket selected.'), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2057,15 +2004,16 @@
                     enddate, tz).strftime("%d/%m/%Y %H:%M:%S")
                 self.flash(_("Outside booking period: ${a} - ${b}",
-                    mapping = {'a': startdate, 'b': enddate}))
+                    mapping = {'a': startdate, 'b': enddate}), type="warning")
             else:
-                self.flash(_("Outside booking period."))
+                self.flash(_("Outside booking period."), type="warning")
             self.redirect(self.url(self.context))
             return
         if not acc_details:
-            self.flash(_("Your data are incomplete."))
+            self.flash(_("Your data are incomplete."), type="warning")
             self.redirect(self.url(self.context))
             return
         if not student.state in acc_details['allowed_states']:
-            self.flash(_("You are in the wrong registration state."))
+            self.flash(_("You are in the wrong registration state."),
+                       type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2073,5 +2021,6 @@
             'booking_session']:
             self.flash(
-                _('Your current session does not match accommodation session.'))
+                _('Your current session does not match accommodation session.'),
+                type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2079,5 +2028,5 @@
             self.flash(
                 _('You already booked a bed space in current ' \
-                    + 'accommodation session.'))
+                    + 'accommodation session.'), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2091,5 +2040,5 @@
             code = get_access_code(pin)
             if not code:
-                self.flash(_('Activation code is invalid.'))
+                self.flash(_('Activation code is invalid.'), type="warning")
                 return
         # Search and book bed
@@ -2103,5 +2052,6 @@
             # XXX: Can be remove if nobody complains.
             if bed.__parent__.__parent__ is None:
-                self.flash(_('System error: Please contact the adminsitrator.'))
+                self.flash(_('System error: Please contact the adminsitrator.'),
+                           type="danger")
                 self.context.writeLogMessage(self, 'fatal error: %s' % bed.bed_id)
                 return
@@ -2118,5 +2068,6 @@
                 # XXX: Can be remove if nobody complains.
                 if bed.__parent__.__parent__ is None:
-                    self.flash(_('System error: Please contact the adminsitrator.'))
+                    self.flash(_('System error: Please contact the adminsitrator.'),
+                               type="warning")
                     self.context.writeLogMessage(self, 'fatal error: %s' % bed.bed_id)
                     return
@@ -2124,10 +2075,11 @@
             else:
                 self.flash(_('There is no free bed in your category ${a}.',
-                    mapping = {'a':acc_details['bt']}))
+                    mapping = {'a':acc_details['bt']}), type="warning")
                 return
         if self.with_ac:
             # Mark pin as used (this also fires a pin related transition)
             if code.state == USED:
-                self.flash(_('Activation code has already been used.'))
+                self.flash(_('Activation code has already been used.'),
+                           type="warning")
                 return
             else:
@@ -2137,5 +2089,6 @@
                 if not invalidate_accesscode(
                     pin,comment,self.context.student.student_id):
-                    self.flash(_('You are not the owner of this access code.'))
+                    self.flash(_('You are not the owner of this access code.'),
+                               type="warning")
                     return
         # Create bed ticket
@@ -2231,5 +2184,6 @@
         if self.context.bed != None and \
               'reserved' in self.context.bed.bed_type:
-            self.flash(_("Students in reserved beds can't be relocated."))
+            self.flash(_("Students in reserved beds can't be relocated."),
+                       type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2237,5 +2191,5 @@
                 self.context.bed != None and \
                 self.context.bed.bed_type == self.context.bed_type:
-            self.flash(_("Student can't be relocated."))
+            self.flash(_("Student can't be relocated."), type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2260,5 +2214,5 @@
             else:
                 self.flash(_('There is no free bed in your category ${a}.',
-                    mapping = {'a':acc_details['bt']}))
+                    mapping = {'a':acc_details['bt']}), type="warning")
                 self.redirect(self.url(self.context))
                 return
@@ -2343,5 +2297,5 @@
                 self.flash(_('Password changed.'))
             else:
-                self.flash( ' '.join(errors))
+                self.flash( ' '.join(errors), type="warning")
         return
 
@@ -2391,13 +2345,13 @@
     def update(self, SUBMIT=None):
         if not self.context.state == ADMITTED:
-            self.flash(_("Wrong state"))
+            self.flash(_("Wrong state"), type="warning")
             self.redirect(self.url(self.context))
             return
         if not self.portrait_uploaded:
-            self.flash(_("No portrait uploaded."))
+            self.flash(_("No portrait uploaded."), type="warning")
             self.redirect(self.url(self.context, 'change_portrait'))
             return
         if not self.all_required_fields_filled:
-            self.flash(_("Not all required fields filled."))
+            self.flash(_("Not all required fields filled."), type="warning")
             self.redirect(self.url(self.context, 'edit_base'))
             return
@@ -2411,8 +2365,9 @@
             code = get_access_code(pin)
             if not code:
-                self.flash(_('Activation code is invalid.'))
+                self.flash(_('Activation code is invalid.'), type="warning")
                 return
             if code.state == USED:
-                self.flash(_('Activation code has already been used.'))
+                self.flash(_('Activation code has already been used.'),
+                           type="warning")
                 return
             # Mark pin as used (this also fires a pin related transition)
@@ -2422,5 +2377,6 @@
             # expect an exception, but the owner might be different
             if not invalidate_accesscode(pin, comment, self.context.student_id):
-                self.flash(_('You are not the owner of this access code.'))
+                self.flash(_('You are not the owner of this access code.'),
+                           type="warning")
                 return
             self.context.clr_code = pin
@@ -2469,5 +2425,5 @@
         self.applyData(self.context, **data)
         if self.dataNotComplete():
-            self.flash(self.dataNotComplete())
+            self.flash(self.dataNotComplete(), type="warning")
             return
         self.flash(_('Clearance form has been saved.'))
@@ -2482,5 +2438,6 @@
                 # This shouldn't happen, but the application officer
                 # might have forgotten to lock the form after changing the state
-                self.flash(_('This form cannot be submitted. Wrong state!'))
+                self.flash(_('This form cannot be submitted. Wrong state!'),
+                           type="danger")
                 return
             IWorkflowInfo(self.context).fireTransition('request_clearance')
@@ -2510,5 +2467,5 @@
             pin = '%s-%s-%s' % (self.ac_prefix, self.ac_series, self.ac_number)
             if self.context.clr_code and self.context.clr_code != pin:
-                self.flash(_("This isn't your CLR access code."))
+                self.flash(_("This isn't your CLR access code."), type="danger")
                 return
         state = IWorkflowState(self.context).getState()
@@ -2516,5 +2473,6 @@
             # This shouldn't happen, but the application officer
             # might have forgotten to lock the form after changing the state
-            self.flash(_('This form cannot be submitted. Wrong state!'))
+            self.flash(_('This form cannot be submitted. Wrong state!'),
+                       type="danger")
             return
         IWorkflowInfo(self.context).fireTransition('request_clearance')
@@ -2541,5 +2499,6 @@
         super(StartSessionPage, self).update()
         if not self.context.next_session_allowed:
-            self.flash(_("You are not entitled to start session."))
+            self.flash(_("You are not entitled to start session."),
+                       type="warning")
             self.redirect(self.url(self.context))
             return
@@ -2553,9 +2512,10 @@
             code = get_access_code(pin)
             if not code:
-                self.flash(_('Activation code is invalid.'))
+                self.flash(_('Activation code is invalid.'), type="warning")
                 return
             # Mark pin as used (this also fires a pin related transition)
             if code.state == USED:
-                self.flash(_('Activation code has already been used.'))
+                self.flash(_('Activation code has already been used.'),
+                           type="warning")
                 return
             else:
@@ -2565,5 +2525,6 @@
                 if not invalidate_accesscode(
                     pin,comment,self.context.student.student_id):
-                    self.flash(_('You are not the owner of this access code.'))
+                    self.flash(_('You are not the owner of this access code.'),
+                               type="warning")
                     return
         try:
@@ -2578,5 +2539,6 @@
                     'pay_pg_fee')
         except ConstraintNotSatisfied:
-            self.flash(_('An error occurred, please contact the system administrator.'))
+            self.flash(_('An error occurred, please contact the system administrator.'),
+                       type="danger")
             return
         self.flash(_('Session started.'))
@@ -2607,4 +2569,9 @@
         if self.context.student.state != PAID:
             emit_lock_message(self)
+            return
+        code = self.context.current_level
+        if code is None:
+            self.flash(_('Your data are incomplete'), type="danger")
+            self.redirect(self.url(self.context))
             return
         super(AddStudyLevelFormPage, self).update()
